---
{{ template "common.rbac.ServiceAccount" (list .) }}

---
{{ template "common.rbac.ClusterRole" (list . "targetd-provisioner.rbac.ClusterRole") }}

{{- define "targetd-provisioner.rbac.ClusterRole" }}
rules:
  - apiGroups:
      - ""
    resources:
      - configmaps
    verbs:
      - create
  - apiGroups:
      - ""
    resources:
      - configmaps
    resourceNames:
      - external-provisioner-targetd-provisioner-iscsi
    verbs:
      - get
      - update
      - patch
  - apiGroups:
      - coordination.k8s.io
    resources:
      - leases
    verbs:
      - create
  - apiGroups:
      - coordination.k8s.io
    resources:
      - leases
    resourceNames:
      - external-provisioner-targetd-provisioner-iscsi
    verbs:
      - get
      - update
      - patch
  - apiGroups:
      - storage.k8s.io
    resources:
      - storageclasses
    verbs:
      - get
      - list
      - watch
  - apiGroups:
      - ""
    resources:
      - persistentvolumeclaims
    verbs:
      - get
      - list
      - watch
      - update
      - patch
  - apiGroups:
      - ""
    resources:
      - persistentvolumes
    verbs:
      - "*"
  - apiGroups:
      - ""
    resources:
      - events
    verbs:
      - create
{{- end }}

---
{{ template "common.rbac.ClusterRoleBinding" (list . "targetd-provisioner.rbac.ClusterRoleBinding") }}

{{- define "targetd-provisioner.rbac.ClusterRoleBinding" }}
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: ClusterRole
  name: {{ template "common.fullname" . }}
subjects:
  - kind: ServiceAccount
    name: {{ template "common.fullname" . }}
    namespace: {{ .Release.Namespace }}
{{- end }}
